// iPing_persistentSettings.js - A iPing_persistent Setting API For Sidebar Gadgets
// by Bruce Williams (e-mail: bwill@microsoft.com, IM: domanite@hotmail.com)

var iPing_gadgetpath = System.Gadget.path
var iPing_slashposition = System.Gadget.path.lastIndexOf("\\")
var iPing_settingspath =iPing_gadgetpath.substr(0,iPing_slashposition)
var iPing_persistentSettingLockFile = iPing_settingspath + "\\iPing_persistentSettingsLockFile.txt";
var iPing_persistentSettingFile = iPing_settingspath + "\\iPing_persistentSettings.txt";
var iPing_persistentSettingTempFile = iPing_settingspath+ "\\iPing_persistentSettings.tmp.txt";
var iPing_persistentSettingBakFile = iPing_settingspath + "\\iPing_persistentSettings.bak";

iPing_slashposition = System.Gadget.path.lastIndexOf("\\")
iPing_settingspath =iPing_gadgetpath.substr(0,iPing_slashposition-2)
iPing_slashposition = iPing_settingspath.lastIndexOf("\\")
iPing_settingspath =iPing_gadgetpath.substr(0,iPing_slashposition-2)
iPing_slashposition = iPing_settingspath.lastIndexOf("\\")
iPing_settingspath =iPing_gadgetpath.substr(0,iPing_slashposition-2)
iPing_slashposition = iPing_settingspath.lastIndexOf("\\")
iPing_settingspath =iPing_gadgetpath.substr(0,iPing_slashposition-2)
iPing_slashposition = iPing_settingspath.lastIndexOf("\\")
iPing_settingspath =iPing_gadgetpath.substr(0,iPing_slashposition-2)
iPing_slashposition = iPing_settingspath.lastIndexOf("\\")
iPing_settingspath =iPing_gadgetpath.substr(0,iPing_slashposition)

var iPing_Export_persistentSettingBakFile = iPing_settingspath + "\\Desktop\\iPing_export.bak";

//
// we'll use five tildes as our magic separator - if you actually put that
// in your setting name or value, we're hosed.  someday maybe we can get more
// clever here and do some encoding.
//
var iPing_persistentSettingDelimiter = "~~~~~";
var iPing_persistentSettingRegExpFormatString = iPing_persistentSettingDelimiter + "(..*)" + iPing_persistentSettingDelimiter + "(.*)";
var iPing_persistentSettingQueue = new Array();
var iPing_persistentSettingPendingTimeouts = 0;
var iPing_persistentSettingFailedRetries = 0;


function getiPing_persistentPendingTimeouts()
{
	getiPing_persistentPendingTimeouts=iPing_persistentSettingPendingTimeouts;
	
	return iPing_persistentSettingPendingTimeouts;
}

function getiPing_persistentSetting(name, callback)
{
	if ((callback == undefined) || (callback == null))
	{
		var errorMsg = "getiPing_persistentSetting: you must specify a callback function";
		iPing_persistentSettingLog(errorMsg);
		throw errorMsg;
	}
	iPing_persistentSettingQueue.push({operation:"get", name:name, callback:callback});
	if (iPing_persistentSettingPendingTimeouts==0)
		{
		window.setTimeout(processiPing_persistentSettingQueue, ((iPing_persistentSettingPendingTimeouts+1)*15) );
		iPing_persistentSettingPendingTimeouts++;
		}
}

function setiPing_persistentSetting(name, value, callback)
{
	iPing_persistentSettingQueue.push({operation:"set", name:name, value:value, callback:callback});
	if (iPing_persistentSettingPendingTimeouts==0)
		{
		window.setTimeout(processiPing_persistentSettingQueue, ((iPing_persistentSettingPendingTimeouts+1)*15));
		iPing_persistentSettingPendingTimeouts++;
		}
}

function processiPing_persistentSettingQueue()
{
	try
	{
		iPing_persistentSettingPendingTimeouts--;
		if (iPing_persistentSettingQueue.length == 0)
		{
			iPing_persistentSettingPendingTimeouts=0;
			return;
		}
		var fs = new ActiveXObject("Scripting.FileSystemObject");
		try
		{
			var lockFile = null;
			try
			{
				lockFile = fs.CreateTextFile(iPing_persistentSettingLockFile, false);
			}
			catch (e)
			{
				if (iPing_persistentSettingPendingTimeouts == 0)
				{
					if (iPing_persistentSettingFailedRetries > 600)
					{
						throw "maximum lock retries exceeded";
					}
					iPing_persistentSettingFailedRetries++;
					iPing_persistentSettingPendingTimeouts++;
					window.setTimeout(processiPing_persistentSettingQueue, ((iPing_persistentSettingPendingTimeouts+1)*15));
				}
				return;
			}
			try
			{
				iPing_persistentSettingFailedRetries = 0;
				while (iPing_persistentSettingQueue.length > 0)
				{
					var returnValue = null;
					var workItem = iPing_persistentSettingQueue.shift();
					if (workItem.operation == "set")
					{
						setiPing_persistentSettingInternal(workItem.name, workItem.value);
					}
					else if (workItem.operation == "get")
					{
						returnValue = getiPing_persistentSettingInternal(workItem.name);
					}
					if ((workItem.callback != undefined) && (workItem.callback != null))
					{
						iPing_persistentSettingScheduleCallback(workItem.callback, returnValue);
					}
				}
			}
			finally
			{
				lockFile.Close();
				fs.DeleteFile(iPing_persistentSettingLockFile, true);
			}
		}
		finally
		{
			fs = null;
		}
	}
	catch (e)
	{
		iPing_persistentSettingFailFast(e.name + ": " + e.message);
	}    
}

function iPing_persistentSettingScheduleCallback(callback, returnValue)
{
	window.setTimeout(function () 
	{
		try
		{
			callback(returnValue);
		}
		catch (e)
		{
			iPing_persistentSettingLog("exception from callback: " + e.name + ": " + e.message);
		}
	}, 0);
}

function setiPing_persistentSettingInternal(name, value)
{
	var fs = new ActiveXObject("Scripting.FileSystemObject");
	try
	{
		var currentFile = null;

		try
		{
			currentFile = fs.GetFile(iPing_persistentSettingFile);
			oldSettings = currentFile.OpenAsTextStream(1); // read-only
		}
		catch (e) // assume file not found - don't know a language-neutral way to detect other exceptions
		{
			var newFile = fs.CreateTextFile(iPing_persistentSettingFile)
			try
			{
				newFile.WriteLine(iPing_persistentSettingDelimiter + name + iPing_persistentSettingDelimiter + value);
			}
			finally
			{
				newFile.Close();
			}
			return;
		}
		
		try
		{
			var settingReplaced = false;
			var template = new RegExp(iPing_persistentSettingRegExpFormatString);
			var newSettings = fs.CreateTextFile(iPing_persistentSettingTempFile, true);
			try
			{
				while (!oldSettings.AtEndOfStream)
				{
					var line = oldSettings.ReadLine();
					var matches = line.match(template);
					var nameFromFile = matches[1];
					var valueFromFile = matches[2];
					if (name == nameFromFile)
					{
						newSettings.WriteLine(iPing_persistentSettingDelimiter + name + iPing_persistentSettingDelimiter + value);
						settingReplaced = true;
					}
					else
					{
						newSettings.WriteLine(iPing_persistentSettingDelimiter + nameFromFile + iPing_persistentSettingDelimiter + valueFromFile);
					}
				}
				if (!settingReplaced)
				{
					newSettings.WriteLine(iPing_persistentSettingDelimiter + name + iPing_persistentSettingDelimiter + value);
				}
			}
			finally
			{
				newSettings.Close();
			}
		}
		finally
		{
			oldSettings.Close();
		}
		
		try
		{
			fs.DeleteFile(iPing_persistentSettingFile, true); // force it, even if it is read-only
		}
		catch (e)
		{
		}
		fs.MoveFile(iPing_persistentSettingTempFile, iPing_persistentSettingFile);
	}
	finally
	{
		fs = null;
	}
}

function getiPing_persistentSettingInternal(name)
{
	var fs = new ActiveXObject("Scripting.FileSystemObject");
	try
	{
		var settingsFile = null;
		try
		{
			settingsFile = fs.GetFile(iPing_persistentSettingFile);
		}
		catch (e)
		{
			// assume file not found - don't know a language-neutral way to detect other exceptions
			return null;
		}
		settings = settingsFile.OpenAsTextStream(1); // read-only
		try
		{
			var template = new RegExp(iPing_persistentSettingRegExpFormatString);
			while (!settings.AtEndOfStream)
			{
				var line = settings.ReadLine();
				var matches = line.match(template);
				var nameFromFile = matches[1];
				var valueFromFile = matches[2];
				if (name == nameFromFile)
				{
					return valueFromFile;
				}
			}		
		}
		finally
		{
			settings.Close();
		}
		return null;
	}
	finally
	{
		fs = null;
	}
}

function iPing_persistentSettingDeleteFile(caller)
{
	if (caller=="main"){
		document.getElementById("loading").style.display = "inline"
		document.getElementById("resetting").style.display = "none"
		document.getElementById("error").style.display = "none"
	
		document.getElementById("head").style.display = "none"
		document.getElementById("tail").style.display = "none"
		document.getElementById("gadgetMainFrame").style.display = "none"
	}
	else if (caller=="settings") {
		OperationStateChange("Log",-1,"Wait...")
		if (iPing_persistentSettingPendingTimeouts>0){OperationStateChange("Log",3,"Failed because file is in use... try later!");return;}
		}
		
	var fs = new ActiveXObject("Scripting.FileSystemObject");
	var settingsFile = null;
	try
	{	//Deleting config
		fs.DeleteFile(iPing_persistentSettingFile);
		var newFile = fs.CreateTextFile(iPing_persistentSettingFile)
		newFile.Close();
		
		if (caller=="settings") {OperationStateChange("Log",1,"Config file file deleted sucesfully.<br><br>Confirm settings to save current configuration otherwise setting must be entered at next run of the gadget.")}
		fs = null;
		return true;		
	}
	catch (e)
	{
		// error during operations
		if (caller=="main"){
			document.getElementById("loading").style.display = "none"
			document.getElementById("resetting").style.display = "none"
			document.getElementById("error").style.display = "inline"
		
			document.getElementById("head").style.display = "none"
			document.getElementById("tail").style.display = "none"
			document.getElementById("gadgetMainFrame").style.display = "none"
		}
		else if (caller=="settings") {OperationStateChange("Log",9,"Error during operation.")}
		
		return false;
	}
	fs = null;
	
	return null;
}

function iPing_persistentSettingBackup(caller)
{
	if (caller=="settings") {
		OperationStateChange("Log",-1,"Wait...")
		if (iPing_persistentSettingPendingTimeouts>0){OperationStateChange("Log",3,"Failed because file is in use... try later!");return;}
		}
	
	var fs = new ActiveXObject("Scripting.FileSystemObject");
	try
	{
		try
		{
			fs.DeleteFile(iPing_persistentSettingBakFile, true); // force it, even if it is read-only
		}
		catch (e)
		{}

		fs.CopyFile(iPing_persistentSettingFile, iPing_persistentSettingBakFile, 1);  
	}
	catch (e)
	{
		if (caller=="settings") {OperationStateChange("Log",9,"Error during operation.<br><br>Can't open copy from config file to backup file.")}
		return false;
	}	
	finally
	{
		fs = null;
	}

	if (caller=="settings") {OperationStateChange("Log",1,"Backup config file created sucesfully.")}
	
	return true;
}

function iPing_persistentSettingRestore(caller)
{
	if (caller=="settings") {
		OperationStateChange("Log",-1,"Wait...")
		if (iPing_persistentSettingPendingTimeouts>0){OperationStateChange("Log",3,"Failed because file is in use... try later!");return;}
		}
	
	var fs = new ActiveXObject("Scripting.FileSystemObject");
	try
	{
		try
		{
			fs.DeleteFile(iPing_persistentSettingFile, true); // force it, even if it is read-only			
		}
		catch (e)
		{}
		
		fs.CopyFile(iPing_persistentSettingBakFile, iPing_persistentSettingFile, 1);  
	}
	catch(e)
	{
		if (caller=="settings") {OperationStateChange("Log",9,"Error during operation.<br><br>Can't copy from backup file to config file.")}
		return false;
	}
	finally
	{
		fs = null;
	}

	if (caller=="settings") {
		OperationStateChange("Log",1,"Restore settings file sucesfully.<br><br>#Checkbox activated#<BR>Close settings WITHOUT save and reload gadget config.")
		dontSaveAndReload.checked= -1;
		}
	
	return true;
}

function iPing_persistentSettingExport(caller)
{
	if (caller=="settings") {
		OperationStateChange("Log",-1,"Wait...")
		if (iPing_persistentSettingPendingTimeouts>0){OperationStateChange("Log",3,"Failed because file is in use... try later!");return;}
		}
	
	var fs = new ActiveXObject("Scripting.FileSystemObject");
	try
	{
		try
		{
			fs.DeleteFile(iPing_Export_persistentSettingBakFile, true); // force it, even if it is read-only
		}
		catch (e)
		{}

		fs.CopyFile(iPing_persistentSettingFile, iPing_Export_persistentSettingBakFile, 1);
	}
	catch (e)
	{
		if (caller=="settings") {OperationStateChange("Log",9,"Error during operation.<br><br>Can't copy config file to backup file.")}
		return false;
	}	
	finally
	{
		fs = null;
	}

	if (caller=="settings") {OperationStateChange("Log",1,"Export file created sucesfully on your DESKTOP.")}
	
	return true;
}

function iPing_persistentSettingImport(caller)
{
	if (caller=="settings") {
		OperationStateChange("Log",-1,"Wait...")
		if (iPing_persistentSettingPendingTimeouts>0){OperationStateChange("Log",3,"Failed because file is in use... try later!");return;}
		}
	
	var fs = new ActiveXObject("Scripting.FileSystemObject");
	try
	{
		fs.CopyFile(iPing_Export_persistentSettingBakFile, iPing_persistentSettingFile, 1);
	}
	catch(e)
	{
		if (caller=="settings") {OperationStateChange("Log",9,"Error during operation.<br><br>Can't copy from export file to config file. Check file existing 'iPing_export.bak' on your desktop.")}
		return false;
	}
	finally
	{
		fs = null;
	}

	if (caller=="settings") {
		OperationStateChange("Log",1,"Import config file sucesfully.<br><br>#Checkbox activated#<BR>Close settings WITHOUT save and reload gadget config.")
		dontSaveAndReload.checked= -1;
		}
	return true;
}

function iPing_persistentSettingLog(message)
{
	System.Debug.outputString("iPing_persistentSettings.js: " + message + "\n");
}

function iPing_persistentSettingFailFast(errorMessage)
{
	iPing_persistentSettingLog("FAILFAST: " + errorMessage);
	//System.Gadget.close();
}
